
QGIS Application - Feature request #12250

Ability to load R packages and easily execute custom R scripts without Python code

2015-02-24 05:56 AM - Irucka Embry

Status: Closed

Priority: Normal

Assignee: Victor Olaya

Category: Processing/Core

Pull Request or Patch supplied:No Resolution: fixed/implemented

Easy fix?: No Copied to github as #: 20435

Description

In an answer to a question posted (

http://gis.stackexchange.com/questions/75320/is-it-possible-to-create-and-run-custom-r-scripts-in-qgis-2-0?s=5|1.4552) at the GIS

Stack Exchange, Guillermo Olmedo posted a link to his Python scripts with R code (saved as .rsx files).

Instead of .rxs files, I would like the ability to load custom R scripts as .R files without any Python code. I would like the ability to load any

installed R package (or download R packages if not already installed and then load) into QGIS when executing a custom R script as well.

Thank you.

History

#1 - 2015-05-08 05:42 AM - Irucka Embry

Hi, would it be possible to use rpy2 (http://rpy.sourceforge.net/) to have the interface to R?

I know that SageMath (http://www.sagemath.org/) includes a working environment for R and it's also Python-based.

Thank you.

#2 - 2015-05-08 08:29 AM - Giovanni Manghi

Irucka Embry wrote:

Hi, would it be possible to use rpy2 (http://rpy.sourceforge.net/) to have the interface to R?

I know that SageMath (http://www.sagemath.org/) includes a working environment for R and it's also Python-based.

Thank you.

We had plugins in the past that worked on top of rpy(2) and they were all a bit painful to use and maintain, and if fact they stopped to be maintained. R is

now integrated in QGIS via the Processing toolbox, there you can run any R script.

#3 - 2015-05-08 06:49 PM - Irucka Embry

- File simple.rsx added

- File simple_R_script_fail.txt added

Thank you for your note about the ability to run any R scripts from QGIS. I originally posted this feature request because I still have yet to be able to use
any of my own R scripts in the SEXTANTE Processing Toolbox. I am using QGIS 2.8.1 on Trisquel 7.0, which is based off of Ubuntu Trusty. I have also

tried in previous versions of QGIS with no success. I have attached the simple R script and the log output from the SEXTANTE  Processing Toolbox. I

attempted to run the script in the custom script window of the Toolbox.

Since rpy(2) was a horrible experience maybe using pyRServe could serve as a better interface to R and to the existing libraries installed on the computer.

I performed some more research today on connecting Python/QGIS and R and the following 3 links are possibilities for making the R accessibility better:

1) https://pythonhosted.org/pyRserve/index.html

pyRServe is a library for connecting Python to an R process running under Rserve. Through such a connection variables can be get and set in R from

Python, and also R-functions can be called remotely.

2) http://www.rforge.net/Rserve/

Rserve

3) http://stackoverflow.com/questions/11716923/python-interface-for-r-programming-language

Python interface for R Programming Language - Stack Overflow

Thank you.

#4 - 2016-01-13 01:23 AM - Alexander Bruy

- Resolution set to fixed/implemented

- Tag deleted (R, statistics, scripts, packages)

- Status changed from Open to Closed

If I'm not wrong, Processing allow you to add scripts in pure R. Reopen if necessary

#5 - 2016-01-13 02:25 PM - Irucka Embry

Processing does not allow scripts to be created in pure R. Here is an example from the scatterplot regressione script (only the last 2 lines are R

commands):

##My scripts=group

##showplots

##Layer=vector

##X=Field Layer

##Y=Field Layer

##Title=string

plot(Layer[[X]], Layer[[Y]], xlab=X, ylab=Y, main=Title)+

abline(lm(Layer[[Y]]~Layer[[X]]))

Thank you.

Irucka Embry

#6 - 2017-05-01 11:01 AM - Giovanni Manghi

- Easy fix? set to No

#7 - 2017-05-01 11:04 AM - Giovanni Manghi
Some providers are being removed from QGIS/Processing (will be available as plugin) and so are their categories in the bug tracker. To not leave them

orphaned of a category they are being reassigned to processing/core.

#8 - 2017-05-01 11:06 AM - Giovanni Manghi

- Category changed from 124 to Processing/Core

Files

simple_R_script_fail.txt 3.09 KB 2015-05-08 Irucka Embry

simple.rsx 598 Bytes 2015-05-08 Irucka Embry
